' ============================================================================
'                                 DEMOTRI
'   Ce programme dmontre graphiquement six algorithmes de tri. Il affiche,
'   dans un ordre alatoire, 25 ou 43 btonnets horizontaux de diffrentes
'   longueurs puis les trie, du plus petit au plus grand.
'
'   Le programme recourt aussi aux instructions SOUND pour gnrer des sons
'   de diffrentes densits, selon la position du btonnet affich. Vous
'   remarquerez que les instructions SOUND ralentissent la vitesse de chaque
'   algorithme de tri afin que vous puissiez suivre le droulement du tri.
'   Les dures ne sont donc indiques que pour servir  la comparaison.
'   Elles ne constituent pas une mesure prcise de la vitesse de tri.
'
'   Si vous utilisez ces sous-programmes de tri dans vos propres programmes,
'   vous noterez peut-tre une diffrence entre leurs vitesses relatives
'   exemple, le tri par change peut tre plus rapide que le tri Shell),
'   en fonction du nombre d'lments  trier et du "mlange" initial.
' ============================================================================
DEFINT A-Z      ' Entier de type implicite.
' Declarer les procdures FUNCTION et SUB, ainsi que le nombre et le type des
' arguments :
  DECLARE FUNCTION EntierAleat (Inferieur, Superieur)
  DECLARE SUB InitRect ()
  DECLARE SUB TriCles ()
  DECLARE SUB VerifEcran ()
  DECLARE SUB TraceCadre (CoteSup, CoteInf, CoteGauche, CoteDroit)
  DECLARE SUB TempsEcoule (LigneCourante)
  DECLARE SUB TriEchange ()
  DECLARE SUB TriEnPile ()
  DECLARE SUB Initialisation ()
  DECLARE SUB TriInsertion ()
  DECLARE SUB PassageBas (NiveauMax)
  DECLARE SUB PassageHaut (NiveauMax)
  DECLARE SUB AfficheUnBatonnet (Ligne)
  DECLARE SUB TriRapide (Bas, Haut)
  DECLARE SUB Reinitialisation ()
  DECLARE SUB TriShell ()
  DECLARE SUB MenuTri ()
  DECLARE SUB PermuteBatonnets (Ligne1, Ligne2)
  DECLARE SUB BasculeSon (Ligne, Colonne)
' Dfinir le type de donne utilis pour contenir les informations de chaque
' btonnet de couleur :
  TYPE TypeTri
     longueur AS INTEGER            ' Longueur du btonnet (l'lement compar
                                    ' dans les diffrents tris).
     ValCouleur AS INTEGER          ' Couleur du btonnet.
     ChaineBatonnet AS STRING * 43  ' Le btonnet (une chane de 43
                                    ' caractres).
  END TYPE
' Dclarer les constantes globales :
  CONST FAUX = 0, VRAI = NOT FAUX, COLONNEGAUCHE = 49
  CONST NBREOPTIONS = 11, NBRETRIS = 6
' Dclarer les variables globales et leur affecter de l'espace mmoire.
' TableauTri et SauveTri sont deux tableaux de type de donne TypeTri dfini
' ci-dessus :
  DIM SHARED TableauTri(1 TO 43) AS TypeTri, SauveTri(1 TO 43) AS TypeTri
  DIM SHARED TitreOption(1 TO NBREOPTIONS) AS STRING * 13
  DIM SHARED HeureDebut AS SINGLE
  DIM SHARED PremierPlan, fond, PasSon, Pause
  DIM SHARED Selection, LigneMax, LigneInit, MaxCouleurs
' Instructions DATA pour les diffrentes options du menu de tri :
  DATA Insertion, Cles, Pile, Echange, Shell, Rapide,
  DATA Bascule son, , < Plus lent, > Plus rapide
' Commencer par l'en-tte du module :
  Initialisation        ' Initialiser les valeurs des donnes.
  MenuTri               ' Afficher le menu de tri.
  WIDTH 80, LigneInit   ' Rtablir le nombre de lignes initial.
  CLS
  END
' CherchLigne, IntercepteMono et IntercepteLigne sont des sous-programmes de
' traitement d'erreurs appels au moyen de la procdure SUB VerifEcran.
' CherchLigne dtermine si le programme a commenc avec 25, 43 ou 50 lignes.
' IntercepteMono dtermine si la carte d'affichage courante est monochrome.
' IntercepteLigne fixe le nombre maximum de lignes possibles (43 ou 25).
CherchLigne:
   IF LigneInit = 50 THEN
      LigneInit = 43
      RESUME
   ELSE
      LigneInit = 25
      RESUME NEXT
   END IF
IntercepteMono:
   MaxCouleurs = 2
   RESUME NEXT
IntercepteLigne:
   LigneMax = 25
   RESUME

' =========================== AfficheUnBatonnet ==============================
'    Affiche TableauTri(Ligne).ChaineBatonnet  la ligne spcifie par le
'    paramtre Ligne, en utilisant la couleur de TableauTri(Ligne).ValCouleur.
' ============================================================================
'
SUB AfficheUnBatonnet (Ligne) STATIC
   LOCATE Ligne, 1
   COLOR TableauTri(Ligne).ValCouleur
   PRINT TableauTri(Ligne).ChaineBatonnet;
END SUB

' ============================== BasculeSon ==================================
'    Inverse la valeur courante de PasSon, puis affiche cette valeur  ct
'    de l'option "Commutation du son" du menu de tri.
' ============================================================================
'
SUB BasculeSon (Ligne, Colonne) STATIC
   PasSon = NOT PasSon
   LOCATE Ligne, Colonne
   IF PasSon THEN
      PRINT ": DESACTIVE";
   ELSE
      PRINT ":  ACTIVE  ";
   END IF
END SUB

' ============================== EntierAleat =================================
'   Fournit un entier alatoire suprieur ou gal au paramtre Inferieur et
'   infrieur ou gal au paramtre Superieur.
' ============================================================================
'
FUNCTION EntierAleat (Inferieur, Superieur) STATIC
   EntierAleat = INT(RND * (Superieur - Inferieur + 1)) + Inferieur
END FUNCTION

' ============================ Initialisation ================================
'    Initialise les tableaux SauveTri et TitreOption. Appelle galement les
'    procdures VerifEcran, InitRect et EntierAleat.
' ============================================================================
'
SUB Initialisation STATIC
   DIM TableauTemp(1 TO 43)
   VerifEcran                   ' Vrifier s'il s'agit d'un cran monochrome
                                ' ou EGA et dfinir le nombre de lignes de
                                ' texte.
   FOR I = 1 TO LigneMax
      TableauTemp(I) = I
   NEXT I
   IndexMax = LigneMax
   RANDOMIZE TIMER              ' Alimenter le gnrateur de nombres
                                ' alatoires.
   FOR I = 1 TO LigneMax
      ' Appeler EntierAleat pour trouver dans TableauTemp un lment alatoire
      ' compris entre 1 et IndexMax, puis affecter la valeur de cet lment 
      ' LongueurBatonnet:
      Index = EntierAleat(1, IndexMax)
      LongueurBatonnet = TableauTemp(Index)
      ' Ecraser la valeur contenue dans TableauTemp(Index) et la remplacer par
      ' la valeur contenue dans TableauTemp(IndexMax) afin que la valeur
      ' contenue dans TableauTemp(Index) ne soit choisie qu'une seule fois :
      TableauTemp(Index) = TableauTemp(IndexMax)
      ' Diminuer la valeur de IndexMax afin que TableauTemp(IndexMax) ne
      ' puisse pas tre choisi lors du passage suivant  travers la boucle :
      IndexMax = IndexMax - 1
      ' Affecter la valeur de LongueurBatonnet  l'lment .Longueur, puis
      ' stocker dans l'lment ChaineBatonnet une chane des caractres du
      ' bloc LongueurBatonnet (ASCII 223: ):
      SauveTri(I).longueur = LongueurBatonnet
      SauveTri(I).ChaineBatonnet = STRING$(LongueurBatonnet, 223)
      ' Stocker la valeur de la couleur approprie dans l'lment .ValCouleur:
      IF MaxCouleurs > 2 THEN
         SauveTri(I).ValCouleur = (LongueurBatonnet MOD MaxCouleurs) + 1
      ELSE
         SauveTri(I).ValCouleur = MaxCouleurs
      END IF
   NEXT I
   FOR I = 1 TO NBREOPTIONS    ' Lire les options du menu
      READ TitreOption(I)      ' DEMONSTRATION DE TRI et les stocker
   NEXT I                      ' dans le tableau TitreOption.
   CLS
   Reinitialisation     ' Affecter  TableauTri des valeurs contenues dans
                        ' SauveTri et tracer  l'cran des btonnets non
                        ' tris.
   PasSon = FAUX
   Pause = 2            ' Initialiser Pause  2 mouvements de balancier
                        ' ( 1/9 seconde).
   InitRect             ' Tracer le cadre du menu de tri et afficher
                        ' les options.
END SUB

' =============================== InitRect ===================================
'    Appelle la procdure TraceCadre pour tracer le cadre autour du menu de
'    tri, puis affiche les diffrentes options stockes dans le tableau
'    TitreOption.
' ============================================================================
'
SUB InitRect STATIC
   TraceCadre 1, 22, COLONNEGAUCHE - 3, 79
   LOCATE 3, COLONNEGAUCHE: PRINT "DEMO DE TRI AVEC QUICKBASIC";
   LOCATE 5
   FOR I = 1 TO NBREOPTIONS - 1
      LOCATE , COLONNEGAUCHE: PRINT TitreOption(I)
   NEXT I
   ' Ne pas afficher la dernire option (> PlusRapide) si la longueur de
   ' la Pause est ramene  un mouvement de balancier :
   IF Pause > 1 THEN LOCATE , COLONNEGAUCHE: PRINT TitreOption(NBREOPTIONS);
   ' Basculer le son puis afficher la valeur courante de PasSon :
   PasSon = NOT PasSon
   BasculeSon 12, COLONNEGAUCHE + 12
   LOCATE NBREOPTIONS + 6, COLONNEGAUCHE
   PRINT "Entrez votre choix (premire"
   LOCATE , COLONNEGAUCHE
   PRINT "lettre : I C P E S R B < > )"
   LOCATE , COLONNEGAUCHE
   PRINT "ou appuyez sur ANNULATION"
   LOCATE , COLONNEGAUCHE
   PRINT "pour terminer le programme: ";
END SUB

' =============================== MenuTri ===================================
'   La procdure MenuTri appelle d'abord la procdure Reinitialisation pour
'   s'assurer que TableauTri n'est pas tri, puis demande  l'utilisateur de
'   slectionner un des choix suivants :
'
'               * Un des algorithmes de tri
'               * Commutation du son
'               * Augmentation ou diminution de la vitesse
'               * Fin du programme
' ============================================================================
'
SUB MenuTri STATIC
   Echap$ = CHR$(27)
   ' Crer une chane compose de tous les choix corrects :
   Option$ = "ICPESR><B" + Echap$
   DO
      ' Rendre le curseur visible :
      LOCATE NBREOPTIONS + 9, COLONNEGAUCHE + 27, 1
      Choix$ = UCASE$(INPUT$(1))          ' Rechercher le choix de
      Selection = INSTR(Option$, Choix$)  ' l'utilisateur et vrifier s'il
                                          ' est repris dans le menu.
      ' L'utilisateur a choisi une des procdures ci-dessous :
      IF (Selection >= 1) AND (Selection <= NBRETRIS) THEN
         Reinitialisation                 ' Remlanger les btonnets.
         LOCATE , , 0                     ' Rendre le curseur invisible.
         PremierPlan = 0                  ' Dfinir les valeurs de la vido
         fond = 7                         ' inverse.
         HeureDebut = TIMER               ' Enregistrer l'heure de dbut.
      END IF
      ' Raliser le branchement vers la procdure adquate, en fonction de la
      ' touche frappe :
      SELECT CASE Choix$
         CASE "I"
            TriInsertion
         CASE "C"
            TriCles
         CASE "P"
            TriEnPile
         CASE "E"
            TriEchange
         CASE "S"
            TriShell
         CASE "R"
            TriRapide 1, LigneMax
         CASE ">"
            ' Rduire la dure de la pause afin d'acclrer le tri, puis
            ' retracer le menu pour effacer toute indication de temps (tant
            ' donn qu'elle ne pourra tre compare aux rsultats futurs) :
            Pause = (2 * Pause) / 3
            InitRect
         CASE "<"
            ' Augmenter la dure de la pause afin de ralentir le tri, puis
            ' retracer le menu pour effacer toute indication de temps (tant
            ' donn qu'elle ne pourra tre compare aux rsultats futurs) :
            Pause = (3 * Pause) / 2
            InitRect
         CASE "B"
            BasculeSon 12, COLONNEGAUCHE + 12
         CASE Echap$
            ' Comme l'utilisateur a appuy sur la touche ANNULATION (ESC),
            ' quitter cette procdure et revenir  l'en-tte du module :
            EXIT DO
         CASE ELSE
            ' Touche incorrecte.
      END SELECT
      IF (Selection >= 1) AND (Selection <= NBRETRIS) THEN
         PremierPlan = MaxCouleurs         ' Dsactiver la vido inverse.
         fond = 0
         TempsEcoule 0                     ' Afficher le temps final.
      END IF
   LOOP
END SUB

' ============================= PassageBas ===================================
'  La procdure PassageBas rtablit les lments de TableauTri compris entre
'  1 et NiveauMax en une "pile" (voir le schma repris  la procdure
'  TriEnPile).
' ============================================================================
'
SUB PassageBas (NiveauMax) STATIC
   I = 1
   ' Dplacer la valeur de TableauTri(1) vers le bas de la pile jusqu' ce
   ' qu'il atteigne son propre noeud (c--d jusqu' ce qu'il soit infrieur
   '  son noeud pre ou jusqu' ce qu'il atteigne NiveauMax, qui constitue
   ' le bas de la pile courante) :
   DO
      Fils = 2 * I             ' Rechercher l'indice du noeud fils.
      ' Quand le bas de la pile est atteint, sortir de cette procdure :
      IF Fils > NiveauMax THEN EXIT DO
      ' S'il y a deux noeuds fils, chercher le plus grand :
      IF Fils + 1 <= NiveauMax THEN
         IF TableauTri(Fils + 1).longueur > TableauTri(Fils).longueur THEN
            Fils = Fils + 1
         END IF
      END IF
      ' Dplacer la valeur vers le bas si elle n'est toujours pas suprieure
      '  l'un ou l'autre de ses fils :
      IF TableauTri(I).longueur < TableauTri(Fils).longueur THEN
         SWAP TableauTri(I), TableauTri(Fils)
         PermuteBatonnets I, Fils
         I = Fils
      ' Sinon, TableauTri a t rtabli en une pile allant de 1  NiveauMax.
      ' Quitter :
      ELSE
         EXIT DO
      END IF
   LOOP
END SUB

' ============================== PassageHaut =================================
'       La procdure PassageHaut convertit en une "pile" les lments de
'       TableauTri compris entre 1 et NiveauMax (voir le schma repris  la
'       procdure TriEnPile).
' ============================================================================
'
SUB PassageHaut (NiveauMax) STATIC
   I = NiveauMax
   ' Dplacer la valeur de TableauTri(NiveauMax) vers le haut de la pile
   ' jusqu' ce qu'il atteigne son propre noeud (c--d jusqu' ce qu'il soit
   ' suprieur  un de ses noeuds fils ou jusqu' ce qu'il atteigne 1, qui
   ' constitue le sommet de la pile) :
   DO UNTIL I = 1
      Pere = I \ 2            ' Rechercher l'indice du noeud pre.
      ' Comme la valeur du noeud courant est encore suprieure  la valeur
      ' de son noeud pre, permuter ces lments de tableau :
      IF TableauTri(I).longueur > TableauTri(Pere).longueur THEN
         SWAP TableauTri(Pere), TableauTri(I)
         PermuteBatonnets Pere, I
         I = Pere
      ' Sinon, l'lment a trouv la place qui lui convient dans la pile.
      '  Quitter alors la procdure :
      ELSE
         EXIT DO
      END IF
   LOOP
END SUB

' =========================== PermuteBatonnets ===============================
'   Appelle AfficheUnBatonnet  deux reprises pour intervertir les
'   deux btonnets en Ligne1 et Ligne2, puis appelle la procdure
'   TempsEcoule.
' ============================================================================
'
SUB PermuteBatonnets (Ligne1, Ligne2) STATIC
   AfficheUnBatonnet Ligne1
   AfficheUnBatonnet Ligne2
   TempsEcoule Ligne1
END SUB

' ============================ Reinitialisation ==============================
'      Rtablit le tableau TableauTri dans son tat initial non tri puis
'      affiche les btonnets de couleur non tris.
' ============================================================================
'
SUB Reinitialisation STATIC
   FOR I = 1 TO LigneMax
      TableauTri(I) = SauveTri(I)
   NEXT I
   FOR I = 1 TO LigneMax
      LOCATE I, 1
      COLOR TableauTri(I).ValCouleur
      PRINT TableauTri(I).ChaineBatonnet;
   NEXT I
   COLOR MaxCouleurs, 0
END SUB

' ============================= TempsEcoule ==================================
'   Affiche le nombre de secondes coules depuis le dbut du sous-programme
'   de tri spcifi. Ce laps de temps couvre  la fois le temps ncessaire
'   au retraage des btonnets et la pause marque lorsque l'instruction
'   SOUND joue une note. Il ne s'agit donc pas d'une mesure prcise de la
'   vitesse de tri.
' ============================================================================
'
SUB TempsEcoule (LigneCourante) STATIC
   CONST FORMAT = "  &###.### secondes "
   ' Afficher en vido inverse la slection courante et le nombre de secondes
   ' coules :
   COLOR PremierPlan, fond
   LOCATE Selection + 4, COLONNEGAUCHE - 2
   PRINT USING FORMAT; TitreOption(Selection), TIMER - HeureDebut;
   IF PasSon THEN
      SOUND 30000, Pause               ' Pas de son, une simple pause.
   ELSE
      SOUND 60 * LigneCourante, Pause  ' Son, donc jouer une note pendant
   END IF                              ' la pause.
   COLOR MaxCouleurs, 0                ' Rtablir les couleurs normales du
                                       ' premier plan et du fond.
END SUB

' ============================== TraceCadre ==================================
'   Trace un cadre rectangulaire au moyen des caractres ASCII de haut rang
'    (201) ,  (187) ,  (200) ,  (188) ,  (186) et  (205). Les
'   paramtres CoteSup, CoteInf, CoteGauche et CoteDroit sont les arguments
'   de ligne et de colonne des coins suprieur gauche et infrieur droit du
'   cadre.
' ============================================================================
'
SUB TraceCadre (CoteSup, CoteInf, CoteGauche, CoteDroit) STATIC
   CONST SGAUCHE = 201, SDROIT = 187, IGAUCHE = 200, IDROIT = 188
   CONST VERTICAL = 186, HORIZONTAL = 205
   LargeurCadre = CoteDroit - CoteGauche - 1
   LOCATE CoteSup, CoteGauche
   PRINT CHR$(SGAUCHE); STRING$(LargeurCadre, HORIZONTAL); CHR$(SDROIT);
   FOR Ligne = CoteSup + 1 TO CoteInf - 1
      LOCATE Ligne, CoteGauche
      PRINT CHR$(VERTICAL); SPC(LargeurCadre); CHR$(VERTICAL);
   NEXT Ligne
   LOCATE CoteInf, CoteGauche
   PRINT CHR$(IGAUCHE); STRING$(LargeurCadre, HORIZONTAL); CHR$(IDROIT);
END SUB

' =============================== TriCles ====================================
'     L'algorithme TriCles parcourt TableauTri en comparant les lments
'     adjacents et en permutant les paires qui ne sont pas classes dans
'     le bon ordre. Il continue ainsi jusqu' ce qu'il ne reste plus de
'     paire  permuter.
' ============================================================================
'
SUB TriCles STATIC
   Limite = LigneMax
   DO
      Interversion = FAUX
      FOR Ligne = 1 TO (Limite - 1)
         ' Deux lments adjacents sont mal classs, permuter leurs valeurs
         ' et retracer ces deux btonnets :
         IF TableauTri(Ligne).longueur > TableauTri(Ligne + 1).longueur THEN
            SWAP TableauTri(Ligne), TableauTri(Ligne + 1)
            PermuteBatonnets Ligne, Ligne + 1
            Interversion = Ligne
         END IF
      NEXT Ligne
      ' Lors du passage suivant, ne pas trier au-del de la dernire
      ' Interversion :
       Limite = Interversion
   LOOP WHILE Interversion
END SUB

' ============================= TriEchange ==================================
'   TriEchange compare chaque lment de TableauTri - en commenant par le
'   premier lment - avec chacun des lments suivants. Si l'un de ceux-ci
'   est infrieur  l'lment courant, il est chang avec ce dernier. Ce
'   mme processus est ensuite rpt pour l'lment suivant de TableauTri.
' ============================================================================
'
SUB TriEchange STATIC
   FOR Ligne = 1 TO LigneMax
      PlusCourteLigne = Ligne
      FOR J = Ligne + 1 TO LigneMax
         IF TableauTri(J).longueur < TableauTri(PlusCourteLigne).longueur THEN
            PlusCourteLigne = J
            TempsEcoule J
         END IF
      NEXT J
      ' Dcouverte d'une ligne plus courte que la ligne courante. Permuter
      ' ces deux lments du tableau :
      IF PlusCourteLigne > Ligne THEN
         SWAP TableauTri(Ligne), TableauTri(PlusCourteLigne)
         PermuteBatonnets Ligne, PlusCourteLigne
      END IF
   NEXT Ligne
END SUB

' =============================== TriEnPile ===================================
'    La procdure TriEnPile appelle deux autres procdures - PassageHaut et
'    PassageBas. PassageHaut transforme TableauTri en une "pile" qui se
'    prsente de la manire illustre ci-dessous :
'
'                               TableauTri(1)
'                               /          \
'                   TableauTri(2)           TableauTri(3)
'                   /          \            /          \
'         TableauTri(4)  TableauTri(5)   TableauTri(6) TableauTri(7)
'          /      \       /       \       /      \      /      \
'        ...      ...   ...       ...   ...      ...  ...      ...
'
'
'    dans laquelle chaque "noeud pre" est suprieur  chacun de ses "noeuds
'    fils". Par exemple, TableauTri(1) est suprieur  TableauTri(2) ou 
'    TableauTri(3), TableauTri(3) est suprieur  TableauTri(6) ou 
'    TableauTri(7), et ainsi de suite.
'
'    Ainsi, une fois que la premire boucle FOR...NEXT de TriEnPile a t
'    excute, le plus grand lment se trouve dans TableauTri(1).
'
'    La deuxime boucle FOR...NEXT de TriEnPile permute l'lment contenu
'    dans TableauTri(1) et l'lment contenu dans LigneMax, reconstitue la
'    pile (avec PassageBas) pour LigneMax - 1, puis permute l'lment
'    contenu dans TableauTri(1) et l'lment contenu dans LigneMax - 1,
'    reconstitue enfin la pile pour LigneMax - 2, et poursuit ainsi jusqu'
'    ce que le tableau soit tri.
' ============================================================================
'
SUB TriEnPile STATIC
   FOR I = 2 TO LigneMax
      PassageHaut I
   NEXT I
   FOR I = LigneMax TO 2 STEP -1
      SWAP TableauTri(1), TableauTri(I)
      PermuteBatonnets 1, I
      PassageBas I - 1
   NEXT I
END SUB

' ============================= TriInsertion =================================
'  La procdure TriInsertion compare la longueur de chaque lment successif
'  de TableauTri aux longueurs de tous les lments prcdents. Quand la
'  procdure dcouvre la place qui convient au nouvel lment, elle l'y
'  insre et repousse tous les autres lments d'une place vers le bas.
' ============================================================================
'
SUB TriInsertion STATIC
   DIM ValTemp AS TypeTri
   FOR Ligne = 2 TO LigneMax
      ValTemp = TableauTri(Ligne)
      LongueurTemp = ValTemp.longueur
      FOR J = Ligne TO 2 STEP -1
         ' Aussi longtemps que la longueur de l'lment J-1 est suprieure 
         ' la longueur de l'lment initial contenu dans TableauTri(Ligne),
         ' continuer  dcaler les lments du tableau vers le bas :
         IF TableauTri(J - 1).longueur > LongueurTemp THEN
            TableauTri(J) = TableauTri(J - 1)
            AfficheUnBatonnet J         ' Afficher le nouveau btonnet.
            TempsEcoule J               ' Afficher le temps coul.
         ' Sinon, quitter la boucle FOR...NEXT :
         ELSE
            EXIT FOR
         END IF
      NEXT J
      ' Insrer la valeur initiale de TableauTri(Ligne) dans TableauTri(J):
      TableauTri(J) = ValTemp
      AfficheUnBatonnet J
      TempsEcoule J
   NEXT Ligne
END SUB

' ============================== TriRapide ===================================
'    TriRapide prend un lment "pivot" alatoire dans TableauTri, puis
'    place d'un ct du pivot tous les lments qui lui sont suprieurs, et
'    de l'autre tous ceux qui lui sont infrieurs. TriRapide est ensuite
'    appel de manire rcursive avec les deux subdivisions cres par le
'    pivot. Quand le nombre d'lments d'une subdivision est gal  deux,
'    les appels rcursifs cessent et le tableau est tri.
' ============================================================================
'
SUB TriRapide (Bas, Haut)
   IF Bas < Haut THEN
      ' Seulement deux lments dans cette subdivision; les permuter s'ils
      ' ne sont pas classs dans le bon ordre, puis mettre fin aux appels
      ' rcursifs :
      IF Haut - Bas = 1 THEN
         IF TableauTri(Bas).longueur > TableauTri(Haut).longueur THEN
            SWAP TableauTri(Bas), TableauTri(Haut)
            PermuteBatonnets Bas, Haut
         END IF
      ELSE
         ' Slectionne un lment de pivot, de manire alatoire, puis le
         ' dplace jusqu' la fin :
         IndexAleat = EntierAleat(Bas, Haut)
         SWAP TableauTri(Haut), TableauTri(IndexAleat)
         PermuteBatonnets Haut, IndexAleat
         Partition = TableauTri(Haut).longueur
         DO
            ' Ramener des cts vers l'lment pivot :
            I = Bas: J = Haut
            DO WHILE (I < J) AND (TableauTri(I).longueur <= Partition)
               I = I + 1
            LOOP
            DO WHILE (J > I) AND (TableauTri(J).longueur >= Partition)
               J = J - 1
            LOOP
            ' Si l'lment pivot n'a pas t atteint, cela signifie que deux
            ' lments situs de part et d'autre de l'lment pivot sont mal
            ' classs. Il faut alors les permuter :
            IF I < J THEN
               SWAP TableauTri(I), TableauTri(J)
               PermuteBatonnets I, J
            END IF
         LOOP WHILE I < J
         ' Remettre l'lment pivot  sa place correcte dans le tableau :
         SWAP TableauTri(I), TableauTri(Haut)
         PermuteBatonnets I, Haut
         ' Appeler de manire rcursive la procdure TriRapide (passer
         ' d'abord la plus petite subdivision afin d'conomiser l'espace
         ' dans la pile) :
         IF (I - Bas) < (Haut - I) THEN
            TriRapide Bas, I - 1
            TriRapide I + 1, Haut
         ELSE
            TriRapide I + 1, Haut
            TriRapide Bas, I - 1
         END IF
      END IF
   END IF
END SUB

' =============================== TriShell ==================================
'   La procdure TriShell est semblable  la procdure TriCles . Toutefois,
'   TriShell commence par comparer les lments loigns (ceux qui sont
'   spars par la valeur de la variable Decalage, qui correspond initialement
'    la moiti de la distance sparant le premier lment du dernier), avant
'   de comparer les lments les plus rapprochs (quand Decalage est gale 
'   un, la dernire itration de cette procdure n'est plus tout simplement
'   qu'un tri par change de paires de cls).
' ============================================================================
'
SUB TriShell STATIC
   ' Dfinir la valeur du dcalage  la moiti du nombre d'enregistrements
   ' contenus dans TableauTri :
   Decalage = LigneMax \ 2
   DO WHILE Decalage > 0             ' Itrer jusqu' ce que le dcalage
                                     ' soit gal  zro.
      Limite = LigneMax - Decalage
      DO
         Interversion = FAUX         ' Prsumer qu'il n'y a aucune
                                     ' interversion pour ce dcalage.
         ' Comparer les lments et intervertir ceux qui ne sont pas classs
         ' dans le bon ordre :
         FOR Ligne = 1 TO Limite
            IF TableauTri(Ligne).longueur > TableauTri(Ligne + Decalage).longueur THEN
               SWAP TableauTri(Ligne), TableauTri(Ligne + Decalage)
               PermuteBatonnets Ligne, Ligne + Decalage
               Interversion = Ligne
            END IF
         NEXT Ligne
         ' Lors du passage suivant, ne pas trier au-del de la dernire
         ' interversion :
         Limite = Interversion - Decalage
      LOOP WHILE Interversion
      ' Si pas d'interversion au dernier dcalage, essayer un autre, plus
      ' petit de moiti :
      Decalage = Decalage \ 2
   LOOP
END SUB

' ============================== VerifEcran ==================================
'       Vrifie le type de moniteur (VGA, EGA, CGA, ou monochrome) et le
'       nombre initial de lignes d'cran (50, 43 ou 25).
' ============================================================================
'
SUB VerifEcran STATIC
   ' Tenter de localiser la 50me ligne, sinon essayer la 43me ligne. Si
   ' cette deuxime tentative choue elle aussi, l'utilisateur est en
   ' mode 25 lignes :
   LigneInit = 50
   ON ERROR GOTO CherchLigne
   LOCATE LigneInit, 1
   ' Essayer une instruction SCREEN 1 pour voir si la carte courante est en
   ' mesure d'afficher des graphiques en couleurs. Si cette tentative
   ' entrane une erreur, ramener MaxCouleurs  2 :
   MaxCouleurs = 15
   ON ERROR GOTO IntercepteMono
   SCREEN 1
   SCREEN 0
   ' Vrifier si le mode 43 lignes est accept. Si ce n'est pas le cas,
   ' excuter ce programme en mode 25 lignes :
   LigneMax = 43
   ON ERROR GOTO IntercepteLigne
   WIDTH 80, LigneMax
   ON ERROR GOTO 0              ' Dsactiver l'interception d'erreurs.
END SUB

