'* QCARTES -- Une base de donnes simple utilisant un fichier
'* de cartes comme interface utilisateur. Chaque enregistrement
'* de la base de donnes est reprsent par une carte.
'* L'utilisateur peut faire dfiler les cartes avec les touches
'* de dfilement habituelles. D'autres commandes permettent
'* d'diter, d'ajouter, de trier, de trouver, de dtruire des cartes.
'*
'* Entre:  Clavier - commandes et entres de l'utilisateur.
'*          Fichier - enregistrements de la base de donnes.
'*
'* Sortie:  Ecran - affichage des cartes et aide.
'*          Fichier - enregistrements de la base de donnes.
'*

' Dbut du programme principal:

'************* Dbut des dclarations et des dfinitions ********************

DEFINT A-Z     'Changement du type de donns par dfaut de simple prcision
			   'en entier.

' Dfinition des noms des touches par leur code ASCII:

CONST ESPACE = 32, ECHAP = 27, ENTREE = 13, TABUL = 9
CONST BAS = 80, HAUT = 72, GAUCHE = 75, DROITE = 77
CONST ORIGINE = 71, TOUCHEFIN = 79, PGSUIV = 81, PGPREC = 73
CONST INSER = 82, SUPPR = 83, RIEN = 0
CONST CTRLD = 4, CTRLG = 7, CTRLH = 8, CTRLS = 19, CTRLV = 22

' Dfinition des noms des couleurs correspondant aux codes des
' couleurs. Pour obtenir la version brillante d'une couleur,
' ajoutez BRILLANT  son nom.

CONST NOIR = 0, BLEU = 1, VERT = 2, CYAN = 3, ROUGE = 4, VIOLET = 5
CONST JAUNE = 6, BLANC = 7, BRILLANT = 8

' Affectation de couleurs aux diffrentes sortes de texte. En modifiant
' la couleur affecte, vous pouvez changer la couleur de l'affichage de
' QCARTES. Les couleurs initiales ont t choisies de telle sorte qu'elles
' fonctionnent aussi bien avec un affichage noir et blanc qu'avec un
' affichage couleur.

CONST FOND = NOIR, NORMAL = BLANC, SURBRI = BLANC + BRILLANT

' Codes pour le texte normal et pour le texte en surbrillance
' (utiliss dans les instructions DATA):

CONST CNORMAL = 0, CSURBRI = 1

' Emplacements  l'cran - initialiss pour un cran  25 lignes.
' Ils peuvent tre modifis pour le mode  43 lignes si vous avez une
' carte EGA ou CGA.

CONST HAUTAIDE = 15, BASAIDE = 23, MARGEAIDE = 60, LARGEURAIDE = 20
CONST CARTESPARECRAN = 6, DERNIERANG = 25

' Constantes symboliques diverses:
					  
CONST FAUX = 0, VRAI = NOT FAUX
CONST CURSEURVIS = 1, CURSEURINVIS = 0

' Noms de fichier:

CONST FICHIERTMP$ = "$$$87y$.$5$"       ' Nom de fichier peu probable

' Noms de champ:

CONST NPERSONNE = 0, NNOTE = 1, NMOIS = 2, NJOUR = 3, NANNEE = 4, NTEL = 5
CONST NRUE = 6, NVILLE = 7, NDEPT = 8, NCODEPOST = 1, NCHAMPS = NCODEPOST + 1

' Dclaration d'un type dfini par l'utilisateur (structure de donnes)
' pour des enregistrements d'un fichier  accs alatoire.

TYPE PERSONNE
	NumCarte   AS INTEGER         'Premier lment: numro de la carte
	Nom        AS STRING * 37     'Prnom suivi du nom
	Note       AS STRING * 31     'Note sur la personne
	Mois       AS INTEGER         'Mois de naissance
	Jour       AS INTEGER         'Jour
	Annee      AS INTEGER         'Anne de naissance
	Tel        AS STRING * 11     'Numro de tlphone
	Rue        AS STRING * 28     'Adresse
	Ville      AS STRING * 11     'Ville
	Dept       AS STRING * 2      'Dpartement
	CodePost   AS STRING * 5      'Code postal
END TYPE

' Dbut des dclarations de procdures SUB:

' Espace rserv
DECLARE SUB ToucheAscii (Choix$, CarteDessus%, DernCarte%)
DECLARE SUB Nettoie (DernCarte%)
DECLARE SUB RetireAide ()
DECLARE SUB TireCartes ()
DECLARE SUB EditeCarte (Carte AS PERSONNE)
DECLARE SUB InitIndex (DernCarte%)
DECLARE SUB ImprimEtiquette (Carte AS PERSONNE)
DECLARE SUB TriIndex (ChampDeTri%, DernCarte%)
DECLARE SUB AideAffichage ()
DECLARE SUB MontreCarteDessus (CarteTravail AS PERSONNE)
DECLARE SUB AideEdition ()
DECLARE SUB AfficheCommandes ()
DECLARE SUB AfficheCartes (CarteDessus%, DernCarte%)

' Dbut des dclarations de procdures FUNCTION:

DECLARE FUNCTION EditeChaine$ (ChaineEntree$, Longueur%, ChampSuivant%)
DECLARE FUNCTION TrouveCarte% (CarteDessus%, DernCarte%)
DECLARE FUNCTION MessageAttente$ (Message$, Ligne%, Colonne%, Longueur%)
DECLARE FUNCTION ChoisitChamp% ()

' Fin des dclarations de procdures.

' Dfinition d'un tableau Index() temporaire pour illustrer l'cran de QCARTES.
REDIM SHARED Index(1) AS PERSONNE

' Dfinition d'un enregistrement servant de carte de travail.

DIM Carte AS PERSONNE

'**************** Fin des dclarations et des dfinitions *******************

' Voici le dbut de la partie excutable de QCARTES.

' Ouverture du fichier de donnes QCARTES.DAT pour
' l'accs alatoire en lui associant le numro 1.



' Pour compter les enregistrements d'un fichier, divisez la longueur
' du fichier par la longueur d'un enregistrement; utilisez la
' division entire (\), non pas la division normale (/). Attribuez
' la valeur rsultante  DernCarte.




' Redfinition du tableau Index pour qu'il contienne tous les enregistrements
' du fichier, plus 20 supplmentaires (ces derniers permettent 
' l'utilisateur d'ajouter des cartes). Ce tableau est dynamique
' - c'est--dire que le nombre des lments de Index() dpend de la
' taille du fichier. De plus, Index() est une procdure partage, de
' sorte qu'elle est disponible pour toutes les procdures SUB et FUNCTION du
' programme.
'
' Remarquez qu'un dispositif d'interception d'erreur permet  QCARTES
' de se terminer avec un message d'erreur si la mmoire disponible
' est insuffisante. Si aucune erreur n'est dtecte, l'interception
' d'erreur est dsactive aprs l'instruction REDIM.




' Utilisez l'instruction en bloc IF...THEN...ELSE pour dcider de charger
' ou non les enregistrements du fichier disque QCARTES.DAT dans le tableau
' d'enregistrements appel Index() et dclar plus haut. Dans la partie IF,
' vous vrifiez la prsence d'enregistrements dans le fichier. S'il y en a,
' DernCarte est suprieur  0 et vous pouvez appeler la procdure InitIndex
' pour recharger les enregistrements dans Index(). Si le fichier ne contient
' pas encore d'enregistrement, DernCarte est gal  0. Dans ce cas, la
' clause ELSE est excute. Le code situ entre ELSE et END IF fait
' commencer le tableau Index()  la carte 1.





' Utilisez la procdure TireCartes pour initialiser l'cran et tirer
' les cartes. Faites de la premire carte celle du dessus. Faites
' des variables CarteDessus et DernCarte des arguments passs  la
' procdure AfficheCartes. L'appel de AfficheCartes place toutes les
' donnes de CarteDessus sur la premire carte visible  l'cran et
' place les renseignements de la ligne du haut (le nom de la personne)
' sur les cartes suivantes.



' Utilisez une instruction DO...LOOP inconditionnelle pour figer
' l'image  l'cran. La partie DO de l'instruction se place sur
' la ligne de code suivante. La partie LOOP doit apparatre juste
' avant l'instruction END. Cette boucle renferme la logique centrale
' qui permet  l'utilisateur de dialoguer avec QCARTES.




' Utilisez une instruction DO...LOOP conditionnelle pour obtenir les
' entres frappes par l'utilisateur. A l'intrieur de la boucle, employez
' la fonction INKEY$ pour saisir la squence de touches frappe, puis
' l'affecter  une variable chane. La partie WHILE de la ligne LOOP ne
' cesse pas de vrifier la variable chane. Tant que vous n'appuyez pas
' sur une touche, INKEY$ ne fait que retourner une chane nulle (c'est-
' -dire de longueur zro), reprsente par "". Ds que vous appuyez sur
' une touche, INKEY$ retourne une chane de longueur suprieure  zro,
' et la boucle se termine.




' Utilisez la fonction LEN pour savoir si Choix$ a une longueur
' suprieure  celle d'un seul caractre (c'est--dire d'un seul
' octet). Si Choix$ est constitu d'un seul caractre (c'est--dire
' s'il a une longueur infrieure  deux octets), alors la touche
' frappe est un "caractre de machine  crire" ordinaire, qu'on
' appelle en gnral "touche ASCII" car elle fait partie du jeu de
' caractres ASCII. Quand l'utilisateur entre un caractre ASCII,
' ceci indique qu'il a choisi une des commandes de QCARTES de la ligne
' du bas de l'cran. Si c'est bien le cas, utilisez la fonction LEN
' pour convertir la touche ASCII en minuscules (au cas o la lettre
' majuscule a t entre).
'
' La clause ELSE n'est excute que si Choix$ a plus d'un
' caractre de longueur (donc s'il ne reprsente pas une touche de
' la ligne de commande). Quand Choix$ n'est pas une touche ASCII,
' il reprsente une touche "tendue". Les touches tendues
' comprennent les touches de DIRECTION du pav numrique, et c'est
' pourquoi le programme QCARTES les recherche. La fonction RIGHT$
' est alors utilise pour liminer l'octet excdentaire, retournant
' une valeur susceptible de correspondre  une des touches de
' DIRECTION. Utilisez une construction SELECT CASE pour rpondre
' aux pressions des touches de DIRECTION du pav numrique.



' Rangement des cartes en fonction de la touche frappe
' par l'utilisateur, puis appel de la procdure
' AfficheCartes pour afficher le tas une fois rang.




' Voici la fin de la boucle inconditionnelle DO.


END

' L'excution de l'en-tte du module s'achve ici. Le programme peut
' se terminer ailleurs pour des raisons justifies, mais le droulement
' normal s'arrte ici. Les instructions se trouvant au-del de END ne
' seront excutes qu'en rponse  d'autres instructions.
						   
' Cette premire tiquette, ErrMemoire, sert au traitement d'erreur.

ErrMemoire:
	PRINT "Manque de mmoire. Impossible de lire le fichier."
	END

' Instructions DATA pour la sortie  l'cran - initialises pour
' 25 lignes. Elles peuvent tre modifies pour un mode d'cran 
' 43 lignes si vous disposez d'une carte EGA ou VGA.

EcranCartes:
DATA "               Ŀ"
DATA "                                                      "
DATA "            ͵"
DATA "                                                     "
DATA "         ͵  "
DATA "                                                    "
DATA "      ͵    "
DATA "                                                   "
DATA "   ͵      "
DATA "                                                  "
DATA "͵        "
DATA " _____________________________________         "
DATA "͵        "
DATA " Note: _______________________________       "
DATA "                                             "    
DATA " Date de                                   "
DATA " Naissance:__/__/__  Tl: __-__-__-__      "
DATA "                                         "
DATA " Adresse: ____________________________   "
DATA "                                       "
DATA " Ville: ___________ Dp: __  CP: _____ "
DATA ""
DATA ""

' Codes de couleurs et chanes pour l'aide en mode affichage:

AideAff:
DATA 0,  "Slectionez"
DATA 0,  "la carte avec:"
DATA 1, "    HAUT"
DATA 1, "    BAS"
DATA 1, "    PG.PREC"
DATA 1, "    PG.SUIV"
DATA 1, "    ORIGINE"
DATA 1, "    FIN"
DATA 1, ""

' Codes de couleurs et chanes pour l'aide en mode dition:

AideEdit:
DATA 0,  "Champ suivant:"
DATA 1, "      TAB"                                            
DATA 0,  "Accepter la carte:"
DATA 1, "      ENTREE"
DATA 0,  "Editer le champ:"
DATA 1, " SUPPR    RETARR"
DATA 1, " DROITE   GAUCHE"
DATA 1, " ORIGINE  FIN"
DATA 1, " INSER    ECHAP"

' Ligne, colonne d'affichage et longueur de chaque champ:

PositionChamps:
DATA 12, 6, 37                      : ' Nom
DATA 14, 12, 31                     : ' Note
DATA 17, 16, 2                      : ' Mois
DATA 17, 19, 2                      : ' Jour
DATA 17, 22, 2                      : ' Annee
DATA 17, 31, 12                     : ' Tel
DATA 19, 15, 29                     : ' Rue
DATA 21, 13, 11                     : ' Ville
DATA 21, 30, 2                      : ' Dept
DATA 21, 38, 5                      : ' CodePost
DATA 0, 0, 0

'*
'* AfficheCartes - Montre les champs de la carte de dessus, ainsi
'* que le premier champ de chaque carte visible.
'*
'* Paramtres: CarteDessus - numro de la carte de dessus.
'*             DernCarte - numro de la dernire carte.
'*
'* Sortie: Ecran
'*
SUB AfficheCartes (CarteDessus, DernCarte)

	' Montrer chaque champ de la carte de dessus.
	CALL MontreCarteDessus(Index(CarteDessus))

	' Montrer le champ Nom pour chaque carte visible.
	Carte = CarteDessus
	RESTORE PositionChamps
	READ Ligne, Colonne, Longueur
	FOR Count = 2 TO CARTESPARECRAN

		' Calculer l'emplacement et le numro de la carte suivante.
		Ligne = Ligne - 2: Colonne = Colonne + 3
		Carte = Carte + 1
		IF Carte > DernCarte THEN Carte = 1

		LOCATE Ligne, Colonne
		PRINT SPACE$(Longueur)

		LOCATE Ligne, Colonne
		PRINT Index(Carte).Nom

	NEXT Count

END SUB

'*
'* AfficheCommandes - Affiche la ligne de commande  l'cran, avec les
'* lettres des touches en surbrillance. Modifiez ce SUB si vous dsirez
'* ajouter des commandes.
'*
'* Paramtres: Aucun
'*
'* Sortie: Ecran
'*
SUB AfficheCommandes

	LOCATE DERNIERANG, 1
	COLOR 3, FOND: PRINT " E";
	COLOR NORMAL, FOND: PRINT "diter   ";
	COLOR 3, FOND: PRINT "A";
	COLOR NORMAL, FOND: PRINT "jouter  ";
	COLOR 3, FOND: PRINT "C";
	COLOR NORMAL, FOND: PRINT "opier   ";
	COLOR 3, FOND: PRINT "D";
	COLOR NORMAL, FOND: PRINT "truire  ";
	COLOR 3, FOND: PRINT "R";
	COLOR NORMAL, FOND: PRINT "echercher  ";
	COLOR 3, FOND: PRINT "T";
	COLOR NORMAL, FOND: PRINT "rier   ";
	COLOR 3, FOND: PRINT "I";
	COLOR NORMAL, FOND: PRINT "mprimer  ";
	COLOR 3, FOND: PRINT "Q";
	COLOR NORMAL, FOND: PRINT "uitter   ";

END SUB

'*
'* AideAffichage - Lit les couleurs et les chanes pour l'aide en mode
'* d'affichage, qui est affiche  l'cran.
'*
'* Paramtres: Aucun
'*
'* Sortie: Ecran
'*
SUB AideAffichage

	' Effacer l'aide prcdente, afficher la nouvelle.
	RetireAide
	RESTORE AideAff
	FOR Ligne = HAUTAIDE TO BASAIDE
		READ Clr
		IF Clr = CNORMAL THEN
			COLOR NORMAL, FOND
		ELSE
			COLOR SURBRI, FOND
		END IF
		LOCATE Ligne, MARGEAIDE
		READ Tmp$
		PRINT Tmp$;
	NEXT

	' Restituer les couleurs et afficher la ligne de commande.
	COLOR NORMAL, FOND
	AfficheCommandes

END SUB

'*
'* AideEdition - Lit les couleurs et les chanes de l'aide en mode
'* d'dition et les affiche  l'cran.
'*
'* Paramtres: Aucun
'*
'* Sortie: Ecran
'*
SUB AideEdition

	' Effacer l'aide prcdente et afficher la nouvelle.
	RetireAide
	RESTORE AideEdit
	FOR Ligne = HAUTAIDE TO BASAIDE
		READ Clr
		IF Clr = CNORMAL THEN
			COLOR NORMAL, FOND
		ELSE
			COLOR SURBRI, FOND
		END IF
		LOCATE Ligne, MARGEAIDE
		READ Tmp$
		PRINT Tmp$;
	NEXT

	' Restituer la couleur normale.
	COLOR NORMAL, FOND

END SUB

'*
'* ChoisitChamp - Permet  l'utilisateur de slectionner un champ avec
'* la touche TAB. TAB dplace au champ suivant. ENTREE slectionne le champ
'* actuel.
'*
'* Paramtres: Aucun.
'*
'* Retour: Numro du champ (commenant  zro).
'*
FUNCTION ChoisitChamp%

	' Saisir la premire position du curseur et initialiser NumChamp.
	RESTORE PositionChamps
	READ Ligne, Colonne, Longueur
	NumChamp = 0

	' Effectuer un cycle parmi les champs avec le curseur.
	DO

		' Placer le curseur sur le champ actuel.
		LOCATE Ligne, Colonne, CURSEURVIS

		' Saisir la frappe de TAB ou d'ENTREE.
		DO
			Touche = ASC(INPUT$(1))
		LOOP UNTIL (Touche = ENTREE) OR (Touche = TABUL)

		' Si ENTREE a t frappe, rendre le curseur
		' invisible et retourner le champ.
		IF Touche = ENTREE THEN
			
			LOCATE , , CURSEURINVIS
			ChoisitChamp% = NumChamp
			EXIT FUNCTION

		' Sinon il s'agit de TAB: passer au champ suivant.
		ELSE

			NumChamp = NumChamp + 1
			READ Ligne, Colonne, Longueur
			IF Ligne = 0 THEN
				RESTORE PositionChamps
				READ Ligne, Colonne, Longueur
				NumChamp = 0
			END IF

		END IF

	LOOP

END FUNCTION

'*
'* EditeCarte - Edite chaque champ d'un enregistrement donn.
'*
'* Paramtres: Carte - L'enregistrement  diter.
'*
'* Retour: Comme Carte est pass par adresse, la version
'*         dite est retourne.
'*
SUB EditeCarte (Carte AS PERSONNE)

	' Initialiser Suivant et continuer  diter chaque champ.
	' Suivant devient FAUX quand l'utilisateur appuie sur ENTREE.

	Suivant = VRAI
	DO

		RESTORE PositionChamps

		' Commencer avec le premier champ.
		READ Ligne, Colonne, Longueur
		LOCATE Ligne, Colonne
		' Editer la chane du champ directement.
		Carte.Nom = EditeChaine(RTRIM$(Carte.Nom), Longueur, Suivant)
		' Le rsultat de l'dition dtermine s'il faut continuer.
		IF Suivant = FAUX THEN EXIT SUB

		READ Ligne, Colonne, Longueur
		LOCATE Ligne, Colonne
		Carte.Note = EditeChaine(RTRIM$(Carte.Note), Longueur, Suivant)
		IF Suivant = FAUX THEN EXIT SUB

		READ Ligne, Colonne, Longueur
		LOCATE Ligne, Colonne
		' Convertir les champs numriques en chanes pour les diter.
		Tmp$ = LTRIM$(STR$(Carte.Mois))
		Tmp$ = EditeChaine(Tmp$, Longueur, Suivant)
		' Reconvertir le rsultat en un nombre.
		Carte.Mois = VAL(Tmp$)
		LOCATE Ligne, Colonne
		PRINT USING "##_/"; Carte.Mois;
		IF Suivant = FAUX THEN EXIT SUB

		READ Ligne, Colonne, Longueur
		LOCATE Ligne, Colonne
		Tmp$ = LTRIM$(STR$(Carte.Jour))
		Tmp$ = EditeChaine(Tmp$, Longueur, Suivant)
		Carte.Jour = VAL(Tmp$)
		LOCATE Ligne, Colonne
		PRINT USING "##_/"; Carte.Jour;
		IF Suivant = FAUX THEN EXIT SUB

		READ Ligne, Colonne, Longueur
		LOCATE Ligne, Colonne
		Tmp$ = LTRIM$(STR$(Carte.Annee))
		Tmp$ = EditeChaine(Tmp$, Longueur, Suivant)
		Carte.Annee = VAL(Tmp$)
		LOCATE Ligne, Colonne
		PRINT USING "##"; Carte.Annee;
		IF Suivant = FAUX THEN EXIT SUB

		READ Ligne, Colonne, Longueur
		LOCATE Ligne, Colonne
		Carte.Tel = EditeChaine(RTRIM$(Carte.Tel), Longueur, Suivant)
		RSET Carte.Tel = Carte.Tel
		IF Suivant = FAUX THEN EXIT SUB

		READ Ligne, Colonne, Longueur
		LOCATE Ligne, Colonne
		Carte.Rue = EditeChaine(RTRIM$(Carte.Rue), Longueur, Suivant)
		IF Suivant = FAUX THEN EXIT SUB

		READ Ligne, Colonne, Longueur
		LOCATE Ligne, Colonne
		Carte.Ville = EditeChaine(RTRIM$(Carte.Ville), Longueur, Suivant)
		IF Suivant = FAUX THEN EXIT SUB

		READ Ligne, Colonne, Longueur
		LOCATE Ligne, Colonne
		Carte.Dept = EditeChaine(RTRIM$(Carte.Dept), Longueur, Suivant)
		IF Suivant = FAUX THEN EXIT SUB

		READ Ligne, Colonne, Longueur
		LOCATE Ligne, Colonne
		Carte.CodePost = EditeChaine(RTRIM$(Carte.CodePost), Longueur, Suivant)
		IF Suivant = FAUX THEN EXIT SUB

	LOOP

END SUB

'*
'* EditeChaine$ - Edite une chane donne. Cette fonction reproduit un
'* jeu de fonctions d'dition utilises dans l'environnement QuickBASIC
'* et dans Windows. Les touches d'dition habituelles sont reconnues,
'* y compris les touches de direction, SUPPR, RET.ARR, INSER (pour les
'* modes d'insertion et de surfrappe), ECHAP et ENTREE. TAB n'est reconnue
'* que si ChampSuivant est VRAI. Les quivalents utilisant CTRL sont
'* reconnus pour la plupart des touches. On peut spcifier une chane
'* nulle si on ne veut pas de valeur initiale. Vous pourriez modifier
'* cette fonction pour traiter d'autres commandes d'dition de QB, telles
'* que CTRL+A (mot prcdent) et CTRL+F (mot suivant).
'*
'* Paramtres: ChaineEntree$ - Chane entre (peut tre nulle).
'*             Longueur - Longueur maximale de la chane (la fonction met
'*                        un signal sonore et refuse les frappes de touches
'*                        suivantes si l'utilisateur essaie d'aller au-del).
'*             ChampSuivant - Drapeau indiquant en entre si la touche TAB
'*                            doit tre accepte; en sortie, indique si
'*                            l'utilisateur a appuy sur TAB (VRAI) ou sur
'*                            ENTREE (FAUX).
'*
'* Entre:  Clavier.
'* Sortie:  Ecran - Les touches autres que celles de contrle sont affiches.
'*          Haut-parleur - Bip si la touche est invalide ou la chane
'*                         trop longue.
'*
'* Retour: Chane dite.
'*
FUNCTION EditeChaine$ (ChaineEntree$, Longueur, ChampSuivant)
STATIC Insertion

	' Initialiser les variables et effacer le champ.
	Travail$ = ChaineEntree$
	Ligne = CSRLIN: Colonne = POS(0)
	PremiereFois = VRAI
	P = LEN(Travail$): MaxP = P
	PRINT SPACE$(Longueur);

	' Comme Insertion est STATIC, sa valeur est conserve entre
	' les appels. Insertion vaut 0 (FAUX) la premire fois que
	' la fonction est appele.
	IF Insertion THEN
		LOCATE Ligne, Colonne, CURSEURVIS, 6, 7
	ELSE
		LOCATE Ligne, Colonne, CURSEURVIS, 0, 7
	END IF

	' Vido inverse en entre.
	COLOR FOND, NORMAL
	PRINT Travail$;

	' Traiter les touches jusqu' la frappe de TAB ou d'ENTREE.
	DO

		' Saisir une touche -- soit un code ASCII d'un octet,
		' soit un code tendu (deux octets).
		DO
			Choix$ = INKEY$
		LOOP WHILE Choix$ = ""

		' Convertir les codes tendus en un octet significatif.
		IF LEN(Choix$) = 2 THEN
			Choix$ = RIGHT$(Choix$, 1)
			SELECT CASE Choix$

				' Convertir les codes tendus en codes de contrle ASCII.
				CASE CHR$(GAUCHE)
					Choix$ = CHR$(CTRLS)
				CASE CHR$(DROITE)
					Choix$ = CHR$(CTRLD)
				CASE CHR$(INSER)
					Choix$ = CHR$(CTRLV)
				CASE CHR$(SUPPR)
					Choix$ = CHR$(CTRLG)

				' Traiter les touches ORIGINE et fin, puisqu'elles
				' n'ont pas de code de contrle. Utiliser RIEN pour
				' indiquer qu'il faut les ignorer.
				CASE CHR$(ORIGINE)
					P = 0
					Choix$ = CHR$(RIEN)
				CASE CHR$(TOUCHEFIN)
					P = MaxP
					Choix$ = CHR$(RIEN)

				' Rendre tous les autres choix de touches invalides.
				CASE ELSE
					Choix$ = CHR$(1)
			END SELECT
		END IF

		' Traiter les codes ASCII d'un octet.
		SELECT CASE ASC(Choix$)

			' Ignorer le code nul.
			CASE RIEN

			' Accepter le champ (et la carte si ChampSuivant est
			' VRAI).
			CASE ENTREE
				ChampSuivant = FAUX
				EXIT DO

			' Accepter le champ si ChampSuivant VRAI. Sinon,
			' la touche TAB est invalide.
			CASE TABUL
				IF ChampSuivant THEN
					EXIT DO
				ELSE
					BEEP
				END IF
							  
			' Restituer la chane originale.
			CASE ECHAP
				Travail$ = ChaineEntree$
				LOCATE Ligne, Colonne, CURSEURINVIS
				PRINT SPACE$(MaxP)
				EXIT DO

			' CTRL+S ou GAUCHE dplacent le curseur vers la gauche.
			CASE CTRLS
				IF P > 0 THEN
					P = P - 1
					LOCATE , P + Colonne
				ELSE
					BEEP
				END IF

			' CTRL+D ou DROITE dplacent le curseur vers la droite.
			CASE CTRLD
				IF P < MaxP THEN
					P = P + 1
					LOCATE , P + Colonne
				ELSE
					BEEP
				END IF

			' CTRL+G ou SUPPR suppriment le caractre sous le curseur.
			CASE CTRLG
				IF P < MaxP THEN
					Travail$ = LEFT$(Travail$, P) + RIGHT$(Travail$, MaxP - P - 1)
					MaxP = MaxP - 1
				ELSE
					BEEP
				END IF

			' CTRL+H ou RET.ARR suppriment le caractre  gauche du curseur.
			CASE CTRLH, 127
				IF P > 0 THEN
					Travail$ = LEFT$(Travail$, P - 1) + RIGHT$(Travail$, MaxP - P)
					P = P - 1
					MaxP = MaxP - 1
				END IF

			' CTRL+V ou INSER alternent entre les modes d'insertion et
			' de surfrappe.
			CASE CTRLV
				Insertion = NOT Insertion
				IF Insertion THEN
					LOCATE , , , 6, 7
				ELSE
					LOCATE , , , 0, 7
				END IF

			' Afficher les caractres ASCII  l'cran.
			CASE IS >= ESPACE

				' Effacer le champ s'il s'agit de la premire frappe
				' de touche, puis commencer au premier caractre.
				IF PremiereFois THEN
					LOCATE , Colonne
					COLOR NORMAL, FOND
					PRINT SPACE$(MaxP);
					LOCATE , Colonne
					P = 0: MaxP = P
					Travail$ = ""
				END IF

				' Si on est en mode d'insertion mode et si le curseur
				' n'est pas au-del de la fin, insrer le caractre.
				IF Insertion THEN
					IF MaxP < Longueur THEN
						Travail$ = LEFT$(Travail$, P) + Choix$ + RIGHT$(Travail$, MaxP - P)
						MaxP = MaxP + 1
						P = P + 1
					ELSE
						BEEP
					END IF

				ELSE
					' Si on est en mode de surfrappe et si le curseur est
					'  la fin (mais pas au-del), insrer le caractre.
					IF P = MaxP THEN
						IF MaxP < Longueur THEN
							Travail$ = Travail$ + Choix$
							MaxP = MaxP + 1
							P = P + 1
						ELSE
							BEEP
						END IF

					' Si on est en mode de surfrappe et avant la fin,
					' crire par-dessus le caractre.
					ELSE
						MID$(Travail$, P + 1, 1) = Choix$
						P = P + 1
					END IF
				END IF

			' Considrer les autres touches comme invalides.
			CASE ELSE
				BEEP
		END SELECT
	   
		' Afficher la chane modifie.
		COLOR NORMAL, FOND
		LOCATE , Colonne, CURSEURINVIS
		PRINT Travail$ + " ";
		LOCATE , Colonne + P, CURSEURVIS
		PremiereFois = FAUX

	LOOP

	' Afficher la chane finale et l'affecter au nom de la fonction.
	COLOR NORMAL, FOND
	LOCATE Ligne, Colonne, CURSEURINVIS
	PRINT Travail$;
	EditeChaine$ = Travail$
	LOCATE Ligne, Colonne

END FUNCTION

'*
'* ImprimEtiquette - Affiche le nom, l'adresse, la ville, le dpartement
'* et le code postal d'une carte. Ce SUB pourrait tre modifi pour afficher
'* l'adresse de l'expditeur ou centrer l'adresse sur une enveloppe.
'*
'* Paramtres: Carte - Toutes les donnes sur une personne.
'*
'* Sortie: Imprimante.
'*
SUB ImprimEtiquette (Carte AS PERSONNE)

	LPRINT Carte.Nom
	LPRINT Carte.Rue
	LPRINT Carte.Ville; ", "; Carte.Dept; Carte.CodePost
	LPRINT

END SUB

'*
'* InitIndex - Lit les enregistrements du fichier et affecte chaque valeur
'*  un lment du tableau d'enregistrements. La valeur des indices
'* respecte l'ordre des enregistrements dans le fichier. L'ordre des
'* enregistrements dans le tableau peut changer  la suite de tris ou
'* d'ajouts, mais le champ NumCarte respectera toujours la position
'* de l'enregistrement dans le fichier.
'*
'* Paramtres: DernCarte - Nombre d'enregistrements dans le tableau.
'*
'* Entre: Fichier "QCARTES.DAT".
'*
SUB InitIndex (DernCarte) STATIC
DIM Carte AS PERSONNE

	FOR Record = 1 TO DernCarte
	
		' Lire un enregistrement du fichier et mettre
		' chaque champ dans le tableau.
		GET #1, Record, Carte
		Index(Record).NumCarte = Record
		Index(Record).Nom = Carte.Nom
		Index(Record).Note = Carte.Note
		Index(Record).Mois = Carte.Mois
		Index(Record).Jour = Carte.Jour
		Index(Record).Annee = Carte.Annee
		Index(Record).Tel = Carte.Tel
		Index(Record).Rue = Carte.Rue
		Index(Record).Ville = Carte.Ville
		Index(Record).Dept = Carte.Dept
		Index(Record).CodePost = Carte.CodePost

	NEXT Record

END SUB

'*
'* MessageAttente$ - Affiche un message d'attente  un endroit donn de
'* l'cran et (facultativement) saisit une rponse de l'utilisateur.
'* Cette fonction peut effectuer trois actions diffrentes suivant
'* la valeur du paramtre Longueur.
'*
'* Paramtres: Message$ - Simple message ou message d'attente
'*                        (le cas chant, "" si pas de message).
'*             Ligne
'*             Colonne
'*             Longueur - une des valeurs suivantes:
'*               <1 - Ne pas attendre de rponse;
'*                1 - Saisir un caractre de rponse;
'*               >1 - Saisir une chane de rponse de longueur
'*                    maximale Longueur.
'*
'* Sortie: Clavier.
'* Sortie: Ecran - Les caractres autres que de contrle sont affichs.
'*
'* Retour: Chane entre par l'utilisateur.
'*
FUNCTION MessageAttente$ (Message$, Ligne, Colonne, Longueur)

	LOCATE Ligne, Colonne
	PRINT Message$;
	
	SELECT CASE Longueur
		CASE IS <= 0    ' Pas de valeur de retour.
			MessageAttente$ = ""
		CASE 1          ' Retour d'un caractre.
			LOCATE , , CURSEURVIS
			MessageAttente$ = INPUT$(1)
		CASE ELSE       ' Retour d'une chane.
			MessageAttente$ = EditeChaine("", Longueur, FAUX)
	END SELECT

END FUNCTION

'*
'* MontreCarteDessus - Montre les champs de la carte de dessus.
'*
'* Paramtres: CarteTravail - Enregistrement  afficher comme carte de dessus.
'*
'* Sortie: Ecran.
'*
SUB MontreCarteDessus (CarteTravail AS PERSONNE)

	' Affiche chaque champ de la carte actuelle.
	RESTORE PositionChamps
	READ Ligne, Colonne, Longueur
	LOCATE Ligne, Colonne
	PRINT SPACE$(Longueur);
	LOCATE Ligne, Colonne
	PRINT CarteTravail.Nom;

	READ Ligne, Colonne, Longueur
	LOCATE Ligne, Colonne
	PRINT SPACE$(Longueur);
	LOCATE Ligne, Colonne
	PRINT CarteTravail.Note;

	READ Ligne, Colonne, Longueur
	LOCATE Ligne, Colonne
	PRINT SPACE$(Longueur);
	LOCATE Ligne, Colonne
	PRINT USING "##_/"; CarteTravail.Mois; CarteTravail.Jour;
	PRINT USING "##"; CarteTravail.Annee;
	READ Ligne, Colonne, Longueur, Ligne, Colonne, Longueur

	READ Ligne, Colonne, Longueur
	LOCATE Ligne, Colonne
	PRINT SPACE$(Longueur);
	LOCATE Ligne, Colonne
	PRINT CarteTravail.Tel;

	READ Ligne, Colonne, Longueur
	LOCATE Ligne, Colonne
	PRINT SPACE$(Longueur);
	LOCATE Ligne, Colonne
	PRINT CarteTravail.Rue;

	READ Ligne, Colonne, Longueur
	LOCATE Ligne, Colonne
	PRINT SPACE$(Longueur);
	LOCATE Ligne, Colonne
	PRINT CarteTravail.Ville;

	READ Ligne, Colonne, Longueur
	LOCATE Ligne, Colonne
	PRINT SPACE$(Longueur);
	LOCATE Ligne, Colonne
	PRINT CarteTravail.Dept;

	READ Ligne, Colonne, Longueur
	LOCATE Ligne, Colonne
	PRINT SPACE$(Longueur)
	LOCATE Ligne, Colonne
	PRINT CarteTravail.CodePost;

END SUB

'*
'* Nettoie - Ecrit tous les enregistrements en mmoire dans un fichier.
'* Les enregistrements dtruits ne seront pas crits. Les enregistrements
'* valides sont crits dans un fichier temporaire. L'ancien fichier est
'* dtruit et le nouveau fichier reoit l'ancien nom.
'*
'* Paramtres: DernCarte - Nombre d'enregistrements valides.
'*
'* Sortie: Enregistrements valides vers "QCARTES.DAT" en passant par
'* FICHIERTMP$.
'*
SUB Nettoie (DernCarte)

	' Ecrire les enregistrements dans un fichier temporaire
	' dans l'odre dans lequel ils ont t tris.
	OPEN FICHIERTMP$ FOR RANDOM AS #2 LEN = LEN(Index(1))
	FOR Carte = 1 TO DernCarte
		PUT #2, Carte, Index(Carte)
	NEXT

	' Dtruire l'ancien fichier et le remplacer par la nouvelle version.
	CLOSE
	KILL "QCARTES.DAT"
	NAME FICHIERTMP$ AS "QCARTES.DAT"

END SUB

'*
'* RetireAide - Affiche des espaces dans la zone rserve  l'aide.
'*
'* Paramtres: Aucun.
'*
'* Sortie: Espaces sur l'cran.
'*
SUB RetireAide

	' Effacer l'aide.
	COLOR NORMAL, FOND
	FOR Ligne = HAUTAIDE TO BASAIDE
		LOCATE Ligne, MARGEAIDE
		PRINT SPACE$(LARGEURAIDE)
	NEXT

	' Effacer la ligne de commande.
	LOCATE DERNIERANG, 1
	PRINT SPACE$(80);

END SUB

'*
'* TireCartes - Initialise la couleur de l'cran, sa largeur et sa hauteur;
'* l'efface et cache le curseur. Affiche ensuite le contour des cartes et
'* l'aide du mode d'affichage.
'*
'* Paramtres: Aucun.
'*
'* Sortie: Texte  l'cran.
'*
SUB TireCartes

	' Effacer l'cran et lui donner sa couleur.
	WIDTH 80, DERNIERANG
	COLOR NORMAL, FOND
	CLS
	LOCATE , , CURSEURINVIS, 0, 7

	' Afficher les lignes de caractres qui forment les cartes.
	RESTORE EcranCartes
	FOR Ligne = 1 TO 23
		LOCATE Ligne, 4
		READ Tmp$
		PRINT Tmp$;
	NEXT

	' Afficher l'aide.
	CALL AideAffichage

END SUB

'*
'* ToucheAscii - Traite les touches ASCII. Vous pouvez ajouter de nouvelles
'* commandes en affectant des actions  des touches que vous ajouteriez  la
'* ligne de commande affiche par le SUB AfficheCommandes. Par exemple, vous
'* pourriez ajouter N (comme Nouveau fichier) pour solliciter de
'* l'utilisateur un nouveau fichier de base de donnes.
'*
'* Paramtres: ChoixUtil$ - Touche frappe par l'utilisateur.
'*         CarteDessus - Numro de l'enregistrement actuel.
'*         DernCarte - Nombre d'enregistrements.
'*
SUB ToucheAscii (ChoixUtil$, CarteDessus%, DernCarte%)
DIM CarteTravail AS PERSONNE

	SELECT CASE ChoixUtil$
		' Editer la carte actuelle.
		CASE "e"
			CALL AideEdition
			Tmp$ = MessageAttente$("Edition de la carte...", DERNIERANG, 1, 0)
			CALL EditeCarte(Index(CarteDessus))
			PUT #1, Index(CarteDessus).NumCarte, Index(CarteDessus)
			LOCATE , , CURSEURINVIS
			CALL AideAffichage

		' Ajout et dition d'une carte vierge ou copie.
		CASE "a", "c"
			IF ChoixUtil$ = "c" THEN
				CarteTravail = Index(CarteDessus)   ' Copie de la carte de dessus.
			ELSE
				CarteTravail.NumCarte = 0        ' Initialiser la nouvelle carte.
				CarteTravail.Nom = ""
				CarteTravail.Note = ""
				CarteTravail.Mois = 0
				CarteTravail.Jour = 0
				CarteTravail.Annee = 0
				CarteTravail.Tel = ""
				CarteTravail.Rue = ""
				CarteTravail.Ville = ""
				CarteTravail.Dept = ""
				CarteTravail.CodePost = ""
			END IF
			CarteDessus = DernCarte + 1
			DernCarte = CarteDessus
			Index(CarteDessus) = CarteTravail
			Index(CarteDessus).NumCarte = CarteDessus
			CALL AfficheCartes(CarteDessus, DernCarte)
			CALL AideEdition
			Tmp$ = MessageAttente$("Edition de la carte...", DERNIERANG, 1, 0)
			CALL EditeCarte(Index(CarteDessus))
			PUT #1, Index(CarteDessus).NumCarte, Index(CarteDessus)
			LOCATE , , CURSEURINVIS
			CALL AideAffichage

		' Placer la carte dtruite  la fin et ajuster la
		' dernire carte.
		CASE "d"
			FOR Carte = CarteDessus TO DernCarte - 1
				SWAP Index(Carte + 1), Index(Carte)
			NEXT Carte
			DernCarte = DernCarte - 1

		' Trouver une carte donne.
		CASE "r"
			CALL AideEdition
			Tmp$ = "Entrez les champs pour la recherche (ceux laisss vierges seront ignors)."
			Tmp$ = MessageAttente$(Tmp$, DERNIERANG, 1, 0)
			Carte = TrouveCarte(CarteDessus, DernCarte)
			IF Carte THEN
				CarteDessus = Carte
			ELSE
				BEEP
				CALL RetireAide
				Tmp$ = "Carte non trouve. Appuyez sur une touche..."
				Tmp$ = MessageAttente$(Tmp$, DERNIERANG, 1, 1)
			END IF
			LOCATE , , CURSEURINVIS
			CALL AideAffichage

		' Trie les cartes suivant un champ donn.
		CASE "t"
			CALL RetireAide
			Tmp$ = "Placez-vous avec TAB sur le champ  trier, puis appuyez sur ENTREE."
			Tmp$ = MessageAttente$(Tmp$, DERNIERANG, 1, 0)
			CALL TriIndex(ChoisitChamp, DernCarte)
			CarteDessus = 1
			CALL AideAffichage

		' Imprime l'adresse de la carte de dessus.
		CASE "i"
			CALL ImprimEtiquette(Index(CarteDessus))

		' Termine l'excution du programme.
		CASE "q", CHR$(ECHAP)
			CALL Nettoie(DernCarte)
			LOCATE , , CURSEURVIS
			CLS
			END
		CASE ELSE
			BEEP
	END SELECT

END SUB

'*
'* TriIndex - Trie les enregistrements en mmoire suivant un champ donn.
'* Aprs le tri, le premier enregistrement en mmoire devient la carte de
'* dessus. Notez que bien que l'ordre change en mmoire, il reste le mme
'* dans le fichier. L'ordre rel dans le fichier est reflt par le champ
'* NumCarte de chaque enregistrement. Ce SUB uilise l'algorithme du tri
'* Shell.
'*
'* Paramtres: ChampDeTri - Numro du champ  trier (commenant  zro).
'*             DernCarte - Numro de la dernire carte.
'*
SUB TriIndex (ChampDeTri, DernCarte)

	' Fixer le dcalage pour la comparaison  la moiti du nombre
	' d'enregistrements.
	Decalage = DernCarte \ 2

	' Poursuivre la boucle jusqu' ce que Decalage soit nul.
	DO WHILE Decalage > 0

		Limite = DernCarte - Decalage

		DO

			' Faire l'hypothse qu'il n'y a pas de permutation pour cette
			' valeur de Decalage.
			Permutation = FAUX

			' Comparer les lments du champ spcifi et permuter ceux
			' qui ne sont pas en ordre.
			FOR I = 1 TO Limite
				SELECT CASE ChampDeTri
					CASE NPERSONNE
						IF Index(I).Nom > Index(I + Decalage).Nom THEN
							SWAP Index(I), Index(I + Decalage)
							Permutation = I
						END IF
					CASE NNOTE
						IF Index(I).Note > Index(I + Decalage).Note THEN
							SWAP Index(I), Index(I + Decalage)
							Permutation = I
						END IF
					CASE NMOIS
						IF Index(I).Mois > Index(I + Decalage).Mois THEN
							SWAP Index(I), Index(I + Decalage)
							Permutation = I
						END IF
					CASE NJOUR
						IF Index(I).Jour > Index(I + Decalage).Jour THEN
							SWAP Index(I), Index(I + Decalage)
							Permutation = I
						END IF
					CASE NANNEE
						IF Index(I).Annee > Index(I + Decalage).Annee THEN
							SWAP Index(I), Index(I + Decalage)
							Permutation = I
						END IF
					CASE NTEL
						IF Index(I).Tel > Index(I + Decalage).Tel THEN
							SWAP Index(I), Index(I + Decalage)
							Permutation = I
						END IF
					CASE NRUE
						IF Index(I).Rue > Index(I + Decalage).Rue THEN
							SWAP Index(I), Index(I + Decalage)
							Permutation = I
						END IF
					CASE NVILLE
						IF Index(I).Ville > Index(I + Decalage).Ville THEN
							SWAP Index(I), Index(I + Decalage)
							Permutation = I
						END IF
					CASE NDEPT
						IF Index(I).Dept > Index(I + Decalage).Dept THEN
							SWAP Index(I), Index(I + Decalage)
							Permutation = I
						END IF
					CASE NCODEPOST
						IF Index(I).CodePost > Index(I + Decalage).CodePost THEN
							SWAP Index(I), Index(I + Decalage)
							Permutation = I
						END IF
				END SELECT

			NEXT I

			' Trier au passage suivant jusqu' l'endroit o la dernire
			' permutation a t effectue.
			Limite = Permutation

		LOOP WHILE Permutation

		' Pas de permutation au dernier dcalage. Essayer un dcalage rduit
		' de moiti.
		Decalage = Decalage \ 2
	LOOP

END SUB

'*
'* TrouveCarte - Trouve un enregistrement donn. L'utilisateur spcifie
'* autant de champs  rechercher qu'il le dsire. La recherche dbute
'*  la carte suivante et se poursuit jusqu' ce que l'enregistrement
'* recherch ou la carte de dpart soit atteinte. Les enregistrements
'* spcifis sont mmoriss entre deux appels pour faciliter les
'* recherches  rptition. Ce SUB pourrait tre amlior pour trouver
'* des concordances partielles.
'*
'* Paramtres: CarteDessus - Numro de la carte de dessus.
'*             DernCarte - Numro de la dernire carte.
'*
'* Paramtres: Aucun.
'*
'* Retour: Numro du champ slectionn (commenant  zro).
'*
FUNCTION TrouveCarte% (CarteDessus%, DernCarte%)

STATIC CarteTmp AS PERSONNE, PasPremier

	' Initialise la chane  RIEN au premier appel. (Notez que les
	' variables CarteTmp et PasPremier, dclares STATIC conservent
	' leur valeur entre deux appels successifs.)
	IF PasPremier = FAUX THEN
		CarteTmp.Nom = ""
		CarteTmp.Note = ""
		CarteTmp.Tel = ""
		CarteTmp.Rue = ""
		CarteTmp.Ville = ""
		CarteTmp.Dept = ""
		CarteTmp.CodePost = ""
		PasPremier = VRAI
	END IF

	' Montrer la carte de dessus, puis utiliser la fonction EditeCarte
	' pour spcifier les champs  rechercher.
	CALL MontreCarteDessus(CarteTmp)
	CALL EditeCarte(CarteTmp)

	' Chercher jusqu' ce qu'une concordance soit trouve
	' o jusqu' ce que toutes les cartes aient t examines.
	Carte = CarteDessus
	DO
		Carte = Carte + 1
		IF Carte > DernCarte THEN Carte = 1
		Trouve = 0

		' Tester le nom pour voir s'il correspond.
		SELECT CASE RTRIM$(UCASE$(CarteTmp.Nom))
			CASE "", RTRIM$(UCASE$(Index(Carte).Nom))
				Trouve = Trouve + 1
			CASE ELSE
		END SELECT
								   
		' Tester le texte de la note.
		SELECT CASE RTRIM$(UCASE$(CarteTmp.Note))
			CASE "", RTRIM$(UCASE$(Index(Carte).Note))
				Trouve = Trouve + 1
			CASE ELSE
		END SELECT
								   
		' Tester le mois.
		SELECT CASE CarteTmp.Mois
			CASE 0, Index(Carte).Mois
				Trouve = Trouve + 1
			CASE ELSE
		END SELECT
								 
		' Tester le jour.
		SELECT CASE CarteTmp.Jour
			CASE 0, Index(Carte).Jour
				Trouve = Trouve + 1
			CASE ELSE
		END SELECT
								 
		' Tester l'anne.
		SELECT CASE CarteTmp.Annee
			CASE 0, Index(Carte).Annee
				Trouve = Trouve + 1
			CASE ELSE
		END SELECT
								 
		' Tester le numro de tlphone.
		SELECT CASE RTRIM$(UCASE$(CarteTmp.Tel))
			CASE "", RTRIM$(UCASE$(Index(Carte).Tel))
				Trouve = Trouve + 1
			CASE ELSE
		END SELECT
								 
		' Tester l'adresse.
		SELECT CASE RTRIM$(UCASE$(CarteTmp.Rue))
			CASE "", RTRIM$(UCASE$(Index(Carte).Rue))
				Trouve = Trouve + 1
			CASE ELSE
		END SELECT
								  
		' Tester la ville.
		SELECT CASE RTRIM$(UCASE$(CarteTmp.Ville))
			CASE "", RTRIM$(UCASE$(Index(Carte).Ville))
				Trouve = Trouve + 1
			CASE ELSE
		END SELECT
								  
		' Tester le dpartement.
		SELECT CASE RTRIM$(UCASE$(CarteTmp.Dept))
			CASE "", RTRIM$(UCASE$(Index(Carte).Dept))
				Trouve = Trouve + 1
			CASE ELSE
		END SELECT
								  
		' Tester le code postal.
		SELECT CASE CarteTmp.CodePost
			CASE "", RTRIM$(UCASE$(Index(Carte).CodePost))
				Trouve = Trouve + 1
			CASE ELSE
		END SELECT

		' Si la concordance est trouve, affecter sa valeur
		'  la fonction et quitter, sinon passer  la carte
		' suivante.
		IF Trouve = NCHAMPS - 1 THEN
			TrouveCarte% = Carte
			EXIT FUNCTION
		END IF

	LOOP UNTIL Carte = CarteDessus

	' Retourner FAUX si aucune concordance n'est trouve.
	TrouveCarte% = FAUX

END FUNCTION

